---
id: 65553159615a8123b190ee43
title: Step 87
challengeType: 20
dashedName: step-87
---

# --description--

It works! Now, you are going to start with an encrypted message to be decrypted.

Change the value of `text` to the string `'mrttaqrhknsw ih puggrur'`.

# --hints--

You should still have a `text` variable.

```js
({ test: () => assert(__userGlobals.has("text")) })
```

Your `text` variable should have the value of `'mrttaqrhknsw ih puggrur'`.

```js
({ test: () => assert.equal(__userGlobals.get("text"), "mrttaqrhknsw ih puggrur") })
```

# --seed--

## --seed-contents--

```py
--fcc-editable-region--
text = 'Hello Zaira!'
custom_key = 'python'
--fcc-editable-region--
def vigenere(message, key, direction=1):
    key_index = 0
    alphabet = 'abcdefghijklmnopqrstuvwxyz'
    final_message = ''

    for char in message.lower():

        # Append any non-letter character to the message
        if not char.isalpha():
            final_message += char
        else:        
            # Find the right key character to encode/decode
            key_char = key[key_index % len(key)]
            key_index += 1

            # Define the offset and the encrypted/decrypted letter
            offset = alphabet.index(key_char)
            index = alphabet.find(char)
            new_index = (index + offset*direction) % len(alphabet)
            final_message += alphabet[new_index]
    
    return final_message

def encrypt(message, key):
    return vigenere(message, key)
    
def decrypt(message, key):
    return vigenere(message, key, -1)
    
encryption = encrypt(text, custom_key)
print(encryption)
decryption = decrypt(encryption, custom_key)
print(decryption)
```
